const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const scoring_schemes = sequelize.define(
    'scoring_schemes',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

content: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  scoring_schemes.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.scoring_schemes.belongsTo(db.test_versions, {
      as: 'test_version',
      foreignKey: {
        name: 'test_versionId',
      },
      constraints: false,
    });



    db.scoring_schemes.hasMany(db.file, {
      as: 'export_pdf',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.scoring_schemes.getTableName(),
        belongsToColumn: 'export_pdf',
      },
    });

    db.scoring_schemes.hasMany(db.file, {
      as: 'export_docx',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.scoring_schemes.getTableName(),
        belongsToColumn: 'export_docx',
      },
    });


    db.scoring_schemes.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.scoring_schemes.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return scoring_schemes;
};


